

'>>>>>>>>>> LISTING_1 >>>>>>>>>>


'MIKROPROCESOROWY ZASILACZ LABORATORYJNY
'DIGITALLY CONTROLLED DC POWER SUPPLY 0..30V / 0..5A
'AVT5585
'By Adam Sobczyk SQ5RWQ (11'16-10'17)

$regfile = "m16adef.dat"
$crystal = 16000000
$hwstack = 40
$swstack = 16
$framesize = 32

'***********************************************************************************************************************
'************************************************ Konfiguracje portw  *************************************************
'***********************************************************************************************************************
'--------------------------------- Konfiguracja przetwornika cyfrowo-analogowego DAC/PWM -------------------------------
Config Portd.5 = Output : Portd.5 = 0
Config Portd.4 = Output : Portd.4 = 1
Config Timer1 = Pwm , Pwm = 10 , Compare A Pwm = Clear_up , Compare B Pwm = Clear_up , Prescale = 1
Enable Timer1
Pwm1a = 0                                                   ' Uo=0V
Pwm1b = 1023                                                ' Im=max.

'---------------------------------------------------- STEROWANIE - WYJCIA ---------------------------------------------
Config Portb.0 = Output : Relay Alias Portb.0 : Relay = 0   ' przekanik sekcji trafa; na start: za. jedna sekcja
Config Portb.4 = Output : Zener Alias Portb.4 : Zener = 1   ' bocznik D7;              na start: D7 zwarta
Config Portb.1 = Output : Cooler Alias Portb.1 : Cooler = 0 ' zaczanie wentylatora;  na start: wyczony
Config Portb.3 = Output : Buzzer Alias Portb.3 : Buzzer = 0 ' sterowanie buzzerem;     na start: wyczony

Config Portd.6 = Output : Led_working Alias Portd.6 : Led_working = 1       '         LED [WORKING]       ; 1=OFF
Config Portd.2 = Output : Led_cooling Alias Portd.2 : Led_cooling = 1       '         LED [COOLING]       ; 1=OFF
Config Portd.1 = Output : Led_overload Alias Portd.1 : Led_overload = 1       '       LED [OVERLOAD]      ; 1=OFF
Config Portd.0 = Output : Led_overheating Alias Portd.0 : Led_overheating = 1       ' LED [OVERHEATING]   ; 1=OFF


'----------------------------------------------------- STEROWANIE - WEJCIA --------------------------------------------
Config Portd.7 = Input : Portd.7 = 1 : Sw1_opt Alias Pind.7 ' dodany pull-up ; [SW1_OPT]
Config Portc.0 = Input : Portc.0 = 1 : Sw2__up Alias Pinc.0 ' dodany pull-up ; [SW2__UP]
Config Portc.1 = Input : Portc.1 = 1 : Sw3_dwn Alias Pinc.1 ' dodany pull-up ; [SW3_DWN]
Config Portb.2 = Input : Portb.2 = 1 : Sw4_set Alias Pinb.2 ' dodany pull-up ; [SW4_SET]
Config Portd.3 = Input : Portd.3 = 1 : Int_ovl Alias Pind.3 ' dodany pull-up ; [INT_OVL] - wej. przerwania nadprd.

'------------------------------------------- Konfiguracja wywietlacza LCD ---------------------------------------------
Config Lcdpin = Pin , Rs = Portc.2 , E = Portc.3 , Db4 = Portc.4 , Db5 = Portc.5 , Db6 = Portc.6 , Db7 = Portc.7
Config Lcd = 16 * 2
Deflcdchar 0 , 7 , 5 , 7 , 32 , 32 , 32 , 32 , 32           ' znak stopnia

'-------------------------------------------------- Ekran powitalny ----------------------------------------------------
Cls : Cursor Off
Upperline : Lcd " DC Power Supply"
Lowerline : Lcd " 0..30V / 0..5A "
Wait 1 : Cls
Upperline : Lcd " AVT5585  v.1.00"
Lowerline : Lcd " by SQ5RWQ 10'17"
Wait 1 : Cls

'--------------------------------------------- STAA I ZMIENNE OPERACYJNE ----------------------------------------------
Const Ku = 0.15841584                                       ' wzmocnienie wzmacniacza napicia = (1k5+100R)/(10k+100R)

Dim Fromadc As Word                                         ' dana pomiarowa z ADC
Dim Prhi As Single , Prlo As Single                         'dane porednie pomiarw ADC z pot. regul. POT1..POT4
Dim Upwm As Single                                          ' zmienna pomocnicza do przeliczania nap. ster. z DAC/PWM
Dim Todacpwm As Word                                        ' dana sterujca DAC/PWM

Dim Uz As Single                                            ' gwne napicie stae, zasilajce blok wykonawczy
Dim Us As Single , Us_temp As Single                        ' zadane napicie wyj. zasilacza: aktualne i poprzednie

Dim Uo As Single                                            ' napicie wyjciowe zasilacza: aktualne
Dim Uo_old As Single                                        ' napicie wyjciowe zasilacza: poprzednie
Dim Uo_tmp As Single                                        ' napicie wyjciowe zasilacza - zmienna pomocnicza
Dim Uo_lcd As Single                                        ' nap. wyj. zasilacza - do wywietl. na LCD w trybie BASIC

Dim Im As Single                                            ' max. dopuszczalny prd wyjciowy (limit) - nastawa
Dim Im_lower As Single                                      ' grny prg podnoszenia Us w obsudze przecienia

Dim Io As Single                                            ' prd wyjciowy zasilacza: aktualny
Dim Io_old As Single                                        ' prd wyjciowy zasilacza: poprzedni
Dim Io_tmp As Single                                        ' prd wyjciowy zasilacza - zmienna pomocnicza
Dim Io_lcd As Single                                        ' prd wyj. zasil. - wywietlany na LCD w trybie BASIC

Dim Fovl As Bit                                             ' flaga stanu przecienia prdowego
Fovl = 0                                                    ' na start: 0 - nie ma przecienia/zwarcia

Dim Tr As Single                                            ' Temperatura radiatora przy tranzystorze 2SC5200
Dim Tr_old As Single                                        ' Tr - warto poprzednia (na potrzeby filtracji zakce)
Tr_old = 18                                                 ' warto pocztkowa dla algorytmu filtracji (18 st.C.)
Dim Tr_tmp As Single                                        ' Tr - zmienna pomocnicza
Dim Trint As Integer                                        ' Tr - wersja Integer do celw wywietlenia i porwnania

Dim Pt As Single : Dim Ptint As Integer                     'moc strat termicznych Pt

Dim Us_chng As Single                                       ' krok zmiany napicia Us w obsudze stanu przecieniu
Dim A As Single                                             ' wspczynnik proporcjonalnoci dla ustawiania Us
Dim B As Single                                             ' wspczynnik proporcjonalnoci dla wyznaczania Uo
Dim C As Single                                             ' wspczynnik proporcjonalnoci dla nastawiania Im
Dim D As Single                                             ' wspczynnik proporcjonalnoci dla wyznaczania Io
Dim E As Single                                             ' wspczynnik proporcjonalnoci dla wyznaczania Tr
Dim F As Single                                             ' wspczynnik proporcjonalnoci dla wyznaczania Uz

Dim Selitem As Byte                                         ' wskanik wybranej pozycji menu (do wywietl. i zmiany)
Selitem = 1                                                 ' wskazanie na pocztek menu

Dim Poschanged As Byte                                      ' wskanik zmiany pozycji menu (trigger odwieenia ekranu)
Poschanged = 1                                              ' 1 -> wyzwl odwieenie ekranu

Dim Us_hi As Byte                                           ' zakres pracy gwnego zasilania: 1 -> wysoki , 0 -> niski
Us_hi = 0                                                   ' zaczone jedno uzwojenie trafa i zwarta dioda Zenera D7


'>>>>>>>>>> LISTING_2 >>>>>>>>>>


'***********************************************************************************************************************
'******** ZMIENNE KONFIGUROWALNE W MENU I ZAPAMITYWANE W EEPROM - deklaracje, autokonfiguracja i prezentacje **********
'***********************************************************************************************************************
' Wywietlanie parametrw konfiguracyjnych (zapisanych w EEPROM) przed rozpoczciem waciwej pracy zasilacza
Dim Show_params As Byte                                     ' 0 -> nie pokazuj, 1 -> pokazuj
Readeeprom Show_params , 1
If Show_params <> 0 And Show_params <> 1 Then
   Show_params = 0                                          ' default: nie wywietlamy parametrw konfiguracyjnych
   Writeeeprom Show_params , 1
End If
If Show_params = 1 Then
   Cls
   Upperline : Lcd "Show_params"
   Lowerline : Lcd Show_params
   Wait 1
End If

' Tryby wywietlania na LCD: BASIC MODE -> 0 / SERVICE MODE -> 1
Dim Lcd_mode As Byte
Readeeprom Lcd_mode , 2
If Lcd_mode <> 0 And Lcd_mode <> 1 Then
   Lcd_mode = 0                                             ' default: LCD w trybie BASIC
   Writeeeprom Lcd_mode , 2
End If
If Show_params = 1 Then
   Cls
   Upperline : Lcd "Lcd_mode"
   Lowerline : Lcd Lcd_mode
   Wait 1
End If

' Uywanie buzzer'a
Dim Buzzer_on As Byte
Readeeprom Buzzer_on , 4
If Buzzer_on <> 0 And Buzzer_on <> 1 Then
   Buzzer_on = 0                                            ' default: nie uywamy buzzer'a
   Writeeeprom Buzzer_on , 4
End If
If Show_params = 1 Then
   Cls
   Upperline : Lcd "Buzzer_on"
   Lowerline : Lcd Buzzer_on
   Wait 1
End If

' Vref - napicie referencyjne, pobierane ze stabilizatora LM7805 (ok. 5V w zakresie: 4.7..5.3V)
Dim Vref As Single
Readeeprom Vref , 8
If Vref < 4.7 Or Vref > 5.3 Then
   Vref = 5.0                                               ' default: 5.00V
   Writeeeprom Vref , 8
End If
Gosub Pars_recalc                                           ' przeliczenie wszystkich parametrw zalenych od Vref
If Show_params = 1 Then
   Cls
   Upperline : Lcd "Vref"
   Lowerline : Lcd Fusing(vref , "#.##") ; " V "
   Wait 1
End If

' Prg zakoczenia chodzenia wentylatorem {STOP COOLER}
Dim Tr0 As Integer                                          '
Readeeprom Tr0 , 12
If Tr0 < 40 Or Tr0 > 60 Then
   Tr0 = 50                                                 ' default: 50 st. C
   Writeeeprom Tr0 , 12
End If
If Show_params = 1 Then
   Cls
   Upperline : Lcd "Tr0"
   Lowerline : Lcd Tr0 ; Chr(0) ; "C"
   Wait 1
End If

' Prg rozpoczcia chodzenia wentylatorem {START COOLER}
Dim Tr1 As Integer
Readeeprom Tr1 , 16
If Tr1 <= Tr0 Or Tr1 > 70 Then
   Tr1 = Tr0 + 10                                           ' default: histereza 10 st.C wzgldem progu wyczenia chodzenia
   Writeeeprom Tr1 , 16
End If
If Show_params = 1 Then
   Cls
   Upperline : Lcd "Tr1"
   Lowerline : Lcd Tr1 ; Chr(0) ; "C"
   Wait 1
End If

' Prg zastosowania procedury przegrzania {OVERHEATING}
Dim Tr2 As Integer
Readeeprom Tr2 , 20
If Tr2 <= Tr1 Or Tr2 > 80 Then
   Tr2 = Tr1 + 10                                           ' default: histereza 10 st.C wzgldem progu zaczenia chodzenia
   Writeeeprom Tr2 , 20
End If
If Show_params = 1 Then
   Cls
   Upperline : Lcd "Tr2"
   Lowerline : Lcd Tr2 ; Chr(0) ; "C"
   Wait 1
End If

' Prg napiciowy dla zaczenia grnego zakresu zasilania i sterowania
Dim Us_hi_on As Single
Readeeprom Us_hi_on , 24
If Us_hi_on < 10 Or Us_hi_on > 20 Then
   Us_hi_on = 15.5
   Writeeeprom Us_hi_on , 24
End If
If Show_params = 1 Then
   Cls
   Upperline : Lcd "Us_hi_on"
   Lowerline : Lcd Fusing(us_hi_on , "#.#") ; " V "
   Wait 1
End If

' Prg napiciowy dla zaczenia dolnego zakresu zasilania i sterowania
Dim Us_hi_off As Single
Readeeprom Us_hi_off , 28
If Us_hi_off < 9 Or Us_hi_off >= Us_hi_on Then
   Us_hi_off = Us_hi_on - 1.0                               ' default: histereza 1.0V wzgldem grnego progu
   Writeeeprom Us_hi_off , 28
End If
If Show_params = 1 Then
   Cls
   Upperline : Lcd "Us_hi_off"
   Lowerline : Lcd Fusing(us_hi_off , "#.#") ; " V "
   Wait 1
End If

' Opnienie dodane w obsudze przerwania od przecienia
Dim Ovldwait As Integer
Readeeprom Ovldwait , 32
If Ovldwait < 1 Or Ovldwait > 10000 Then
   Ovldwait = 5000                                          ' default: 5000us (bardzo "mikka" reakcja)
   Writeeeprom Ovldwait , 32
End If
If Show_params = 1 Then
   Cls
   Upperline : Lcd "Ovldwait"
   Lowerline : Lcd Ovldwait ; " usek. "
   Wait 1
End If

Cls

'---------------------------------- Konfiguracja przetwornika analogowo-cyfrowego ADC ----------------------------------
Config Adc = Single , Prescaler = Auto , Reference = Avcc   ' Vref = ca. 5.0V +/- 5% max. -> Vref wpisywane w menu
Start Adc

'--------------------------------- Konfiguracja zewntrznego przerwania sprztowego INT1 -------------------------------
Config Int1 = Low Level
On Int1 Overload
Enable Int1
Enable Interrupts


'>>>>>>>>>> LISTING_3 >>>>>>>>>>


'***********************************************************************************************************************
'********************************************* GWNA PTLA PROGRAMU ***************************************************
'***********************************************************************************************************************
Cursor Off , Noblink
Led_working = 0                                             ' rozpoczcie normalnej pracy urzdzenia
Do
  '**************************** MENU - warunkowe wejcie *****************************
   If Sw1_opt = 0 Then
      ' wstrzymanie normalnej pracy urzdzenia
      Im = 5.0 : Gosub Ustaw_im
      Us = 0 : Gosub Ustaw_us
      Led_working = 1 : Led_overload = 1 : Buzzer = 0 : Fovl = 0
      ' waciwe wejcie do menu
      Gosub Menu
      ' powrt do normalnej pracy urzdzenia
      Led_working = 0
   End If

  '************************************ ODCZYTY **************************************
  '------------------------------------ NAPICIE -------------------------------------
  'Warunkowy pomiar gwnego napicia zasilajcego Uz w serwisowym trybie wywietlania
   If Lcd_mode = 1 Then
      Gosub Pomiar_uz
   End If
  'Odczyt nastaw potencjometrw regulacji napicia wyjciowego Us (POT1..POT2)
   If Fovl = 0 Then                                         ' jeli nie ma stanu przecienia nadprdowego
      Gosub Odczyt_us
   End If
  'Pomiar wartoci napicia wyjciowego Uo
   Gosub Pomiar_uo
   '------------------------------------ PRD --------------------------------------
  'Odczyt nastaw potencjometrw regulacji maksymalnego prdu wyjciowego Im (POT3..POT4)
   Gosub Odczyt_im
   'Pomiar wartoci prdu wyjciowego Io
   Gosub Pomiar_io
  '---------------------------------- TEMPERATURA ----------------------------------
  'Pomiar temperatury radiatora Tr
   Gosub Pomiar_tr

  '*********************************** REGULACJE *************************************
  '------------------------------------ NAPICIE -------------------------------------
  'Ustawienie napicia wyjciowego Uo
   If Fovl = 0 Then                                         ' nie ma stanu przecienia prdowego
      Gosub Ustaw_us
   Elseif Int_ovl = 1 And Io < Im_lower Then                ' tryb obsugi przecienia poniej limitu prd. Im_lower
      Us_temp = Us                                          ' zapamitaj aktualn warto Us
      Gosub Odczyt_us                                       ' odczytaj aktualn nastaw Us z gaek POT1..POT2
      If Us_temp < Us Then                                  ' jeeli Us_temp<Us (za niskie), to zwiksz Us
         Us = Us_temp + Us_chng : Gosub Ustaw_us
      Else                                                  ' Us_temp signo Us -> koniec obsugi przecienia
         Led_overload = 1 : Buzzer = 0 : Fovl = 0           ' zgaszenie sygnalizacji i flagi
      End If
   End If
   '-------------------------------------- PRD --------------------------------------
   'Ustawienie referencji dla limitu prdu Im, ograniczajcego prd wyjciowy Io
   Gosub Ustaw_im
  '----------------------------------- TEMPERATURA -----------------------------------
  ' Regulacja temperatury radiatora
   Select Case Trint                                        ' analiza zakresu Tr
      Case Is < Tr0 : Cooler = 0 : Led_cooling = 1          ' poniej progu wyczenia
      Case Tr0 To Tr1 :                                     ' zakres bez zmian
      Case Tr1 To Tr2 : Cooler = 1 : Led_cooling = 0        ' nad progiem wczenia
      Case Is > Tr2 : Gosub Overheating                     ' nad progiem przegrzania
   End Select

  '********************************** PREZENTACJE ************************************
   If Lcd_mode = 0 Then
      '*************************** TRYB PODSTAWOWY / BASIC ****************************
      'Prezentacja wartoci napicia wyjciowego Uo
      Gosub Filtruj_uo_lcd : Locate 1 , 1 : Lcd "U=" ; Fusing(uo_lcd , "#.##") ; "V "
      'Prezentacja wartoci prdu wyjciowego Io
      Gosub Filtruj_io_lcd : Locate 1 , 9 : Lcd " I=" ; Fusing(io_lcd , "#.##") ; "A "
      'Prezentacja nastaw limitu prdu Im
      Locate 2 , 1 : Lcd "Im=" ; Fusing(im , "#.##") ; "A "
      'Prezentacja temperatury radiatora Tr
      Locate 2 , 10 : Lcd "T=" ; Trint ; Chr(0) ; "C "
   Else
      '************************** TRYB SERWISOWY / SERVICE ***************************
      Upperline
      '----------------------------------- NAPICIE ------------------------------------
      Lcd Fusing(uz , "#.#") ; ">"                          ' gwne nap. zasilajce Uz
      Lcd Fusing(us , "#.##") ; ">"                         ' nastawa napicia wyj. Us
      Lcd Fusing(uo , "#.##") ; "  "                        ' napicia wyjciowe Uo
      Lowerline
      '----------------------------------- PRD ---------------------------------------
      Lcd Fusing(im , "#.##") ; ">"                         ' nastawa limitu prdu Im
      Lcd Fusing(io , "#.##") ; ">"                         ' prdu wyjciowy Io
      '----------------------- PARAMETRY MOCOWE I TERMICZNE ---------------------------
      'Straty termiczne Pt
      Pt = Uz - Uo : Pt = Pt * Io : Ptint = Round(pt) : Lcd Ptint ; ">"
      Lcd Trint ; "  "                                      ' temperatura radiatora
   End If
Loop


'>>>>>>>>>> LISTING_4 >>>>>>>>>>


'***********************************************************************************************************************
'*********************************************** PODPROGRAMY PODSTAWOWE ************************************************
'***********************************************************************************************************************

' Wyliczenie parametrw bdcych funkcjami parametru Vref
Pars_recalc:
   Us_chng = Vref / 1024 : Us_chng = Us_chng / Ku
   A = Ku * 1024 : A = A / Vref
   B = Vref * 0.0061705767                                  ' B = Vref * 6.3125 / 1023 = Vref * 0.0061705767
   C = 921.6 / Vref                                         ' C = 0.1 * 9 / Vref * 1024 = 921.6 / Vref
   D = Vref * 0.0010861301                                  ' D = Vref / 1023 * 10 / 9 = Vref * 0.0010861301
   E = Vref * 0.097751710                                   ' E = Vref / 1023 * 100 = Vref * 0.097751710
   F = Vref * 0.0097751710                                  ' F = Vref / 1023 * 10 = Vref * 0.0097751710
Return

' Procedura obsugi przerwania INT1, wygenerowanego przez komparator U5B po przekroczeniu limitu prdowego
Overload:
   Fovl = 1 : Led_overload = 0 : Buzzer = Buzzer_on         ' ustawienie flagi i sygnalizacji przecienia prdowego
   ' Redukacja napicia sterujcego Us o pojedynczy krok Us_chng lub wprost do 0V
   If Us >= Us_chng Then
      Us = Us - Us_chng
   Elseif Us > 0 Then
      Us = 0
   End If
   Gosub Ustaw_us                                           ' ustawienie zmienionego nap. Us
   Waitus Ovldwait                                          ' konfigurowalne opnienie czasowe
Return

' Procedura awaryjnego chodzenia urzdzenia z wyczonym wyjciem ukadu {OVERHEATING}
Overheating:
   ' - wprowadzenie zasilacza w stan ptli nieskoczonej z warunkiem wyjcia opartym o spadek temperatury poniej progu Tr1.
   Us = 0 : Gosub Ustaw_us                                  ' zamknicie wyjcia zasilania
   Cooler = 1                                               ' wczenie chodzenia
   ' Sygnalizacja LED: anormalna praca/chodzenie/przegrzanie oraz wczenie buzzera
   Led_working = 1 : Led_cooling = 0 : Led_overheating = 0 : Buzzer = Buzzer_on
   ' Ptla "nieskoczona" komunikacji  i obsugi stanu przegrzania - z warunkiem opuszczenia: Tr<Tr1
   Cls
   Upperline : Lcd "***OVERHEATING**"
   Do
      Lowerline : Lcd "*SYSTEM**CLOSED*"
      Wait 1
      Lowerline : Lcd "**UNTIL*COOLED**"
      Wait 1
      Gosub Pomiar_tr
      Lowerline : Lcd "    T=" ; Trint ; Chr(0) ; "C     "
      Wait 1
   Loop Until Trint < Tr1
   ' Aktualizacja sygnalizacji LED oraz wyczenie buzzera
   Led_working = 0 : Led_overheating = 1 : Buzzer = 0
   Cls
Return

' Wyznaczanie nowej wartoci nap. Us na podstawie nastaw potencjometrw POT1 i POT2
Odczyt_us:
   Fromadc = Getadc(4)                                      ' pomiar z ADC (POT1)
   'Prhi = Fromadc / 1023 : Prhi = 25.0 * Prhi               ' przeliczenie etapami
   Prhi = Fromadc * 0.024437927                             ' przeliczenie skrcone
   Fromadc = Getadc(5)                                      ' pomiar z ADC (POT2)
   'Prlo = Fromadc / 1023 : Prlo = 5.0 * Prlo                ' przeliczenie etapami
   Prlo = Fromadc * 0.0048875855                            ' przeliczenie skrcone
   Us = Prhi + Prlo                                         ' sumowanie obu nastaw
Return

' Ustawianie nowej wartoci nap. Us
Ustaw_us:
  'Ustalanie zakresu sterowania diod Zenera i przekanikiem trafa - z zastosowan histerez
   If Us > Us_hi_on And Us_hi = 0 Then                      ' przekroczony prg zacz. stanu wysokiego w stanie niskim
      Relay = 1                                             ' zaczanie obu sekcji trafa
      Waitms 150                                            ' stabilizacja wartoci Uz; 50..250ms (5..25 x T @ F=100Hz)
      Zener = 0 : Us_hi = 1                                 ' aktywacja d.Z. D7, status pracy w wyszym zakresie napi
   Elseif Us < Us_hi_off And Us_hi = 1 Then                 ' przekroczony prg zacz. stanu niskiego w stanie wysokim
      Zener = 1 : Relay = 0                                 ' deaktywacja d.Z. D7, zaczenie jednej sekcji trafa
      Us_hi = 0                                             ' status pracy w niszym zakresie napi
   End If
  'Przeliczenie napicia sterujcego Us (odpowiada podanemu Uo) na sowo sterujce DAC/PWM, czyli Upwm
   'Upwm = Ku * Us : Upwm = 1024 * Upwm : Upwm = Upwm / Vref ' przeliczenie etapami
   Upwm = A * Us                                            ' przeliczenie skrcone
   Todacpwm = Round(upwm) : Pwm1a = Todacpwm                ' ustawienie sowa DAC/PWM (po zaokrgleniu i rzutowaniu)
Return

' Pomiar napicia wyjciowego Uo
Pomiar_uo:
   Fromadc = Getadc(0)                                      ' pomiar z ADC
   'Uo = Fromadc : Uo = Uo * Vref : Uo = Uo / 1023 : Uo = Uo * 6.3125     ' przeliczenie etapami
   Uo = B * Fromadc                                         ' przeliczenie skrcone
Return

' Filtracja dolnoprzepustowa IIR napicia Uo na potrzeby prezentacji dla trybu LCD podstawowego (BASIC)
Filtruj_uo_lcd:
   ' Formua IIR: Uo_lcd(t) = 0.8 * Uo_lcd(t-1) + 0.2 * Uo(t)
   Uo_tmp = 4 * Uo_old : Uo_tmp = Uo_tmp + Uo : Uo_lcd = 0.2 * Uo_tmp : Uo_old = Uo_lcd
Return

' Wyznaczanie nowej wartoci limitu prdu Im oraz granicy podnoszenia napicia Us w stanie przecienia Im_lower
Odczyt_im:
   Fromadc = Getadc(6)                                      ' pomiar z ADC (POT3)
   'Prhi = Fromadc / 1023 : Prhi = 4.0 * Prhi                ' przeliczenie etapami
   Prhi = Fromadc * 0.0039100684                            ' przeliczenie skrcone
   Fromadc = Getadc(7)                                      ' pomiar z ADC (POT4)
   'Prlo = Fromadc / 1023 : Prlo = 1.0 * Prlo                ' przeliczenie etapami
   Prlo = Fromadc * 0.00097751710                           ' przeliczenie skrcone
   Im = Prhi + Prlo                                         ' sumowanie obu nastaw
   If Im <= 0.1 Then                                        ' ograniczenie wartoci minimalnej Im do 100mA
      Im = 0.1
   End If
   'Zaokrglenie kroku zmian limitu Im do 50mA w trybie wywietlania LCD podstawowym (BASIC)
   If Lcd_mode = 0 Then
      Im = 20 * Im : Im = Round(im) : Im = 0.05 * Im
   End If
   Im_lower = Im - 0.035                                    ' grna granica prdu Io przy wychodzeniu z przecienia
Return

' Ustawienie elektrycznej wartoci progu Im dla komparatora U5B
Ustaw_im:
   'Upwm = 0.1 * Im : Upwm = 9 * Upwm : Upwm = Upwm / Vref : Upwm = 1024 * Upwm  ' przeliczenie etapami
   Upwm = C * Im                                            ' przeliczenie skrcone
   Todacpwm = Round(upwm) : Pwm1b = Todacpwm                ' zaokrglenie i nastawienie wartoci DAC/PWM
Return

' Pomiar prdu wyjciowego Io
Pomiar_io:
   Fromadc = Getadc(1)                                      ' pomiar z ADC
   'Io = Fromadc : Io = Io * Vref : Io = Io / 1023 : Io = Io * 10 : Io = Io / 9  ' przeliczenie etapami
   Io = D * Fromadc                                         ' przeliczenie skrcone
Return

' Filtracja dolnoprzepustowa IIR prdu Io na potrzeby prezentacji dla trybu LCD podstawowego (BASIC)
Filtruj_io_lcd:
   ' Formua IIR: Io_lcd(t) = 0.8 * Io_lcd(t-1) + 0.2 * Io(t)
   Io_tmp = 4 * Io_old : Io_tmp = Io_tmp + Io : Io_lcd = 0.2 * Io_tmp : Io_old = Io_lcd
Return

' Pomiar temperatury radiatora Tr
Pomiar_tr:
   Fromadc = Getadc(2)                                      ' pomiar z ADC
   ' Parametry przetwarzania T->U czujnika MCP9700AE: 0 st.C.->500mV + 10mV/st.C
   'Tr = Fromadc : Tr = Tr * Vref : Tr = Tr / 1023 : Tr = Tr - 0.5 : Tr = Tr * 100 ' przeliczenie etapami
   Tr = E * Fromadc : Tr = Tr - 50                          ' przeliczenie skrcone
   ' Filtracja dolnoprzepustowa IIR temperatury radiatora Tr na potrzeby sterowania i prezentacji na LCD
   ' Formua IIR: Tr(t) = 0.98 * Tr(t-1) + 0.02 * Tr(t)
   Tr_tmp = 49 * Tr_old : Tr_tmp = Tr_tmp + Tr : Tr = 0.02 * Tr_tmp : Tr_old = Tr : Trint = Round(tr)
Return

' Pomiar gwnego napicia Uz (wyprostowanego i odfiltrowanego), zasilajcego blok stabilizatora
Pomiar_uz:
   Fromadc = Getadc(3)                                      ' pomiar z ADC
   'Uz = Fromadc : Uz = Uz * Vref : Uz = Uz / 1023 : Uz = Uz * 10  ' przeliczenie etapami
   Uz = F * Fromadc                                         ' przeliczenie skrcone
Return


'>>>>>>>>>> LISTING_5 >>>>>>>>>>


'***********************************************************************************************************************
'********************************************** PODPROGRAMY OBSUGI MENU ***********************************************
'***********************************************************************************************************************
' Gwne menu konfiguracji parametrw pracy zasilacza
Menu:
   Cls
   Upperline : Lcd "*** Entering ***"
   Lowerline : Lcd "***** Menu *****"
   Wait 1
   Cls
   Poschanged = 1                                           ' flaga zmian w menu -> wymuszenie wywietlenia na pocztek

   Do
      If Poschanged = 1 Then                                ' wywietl ponownie menu, jeli bya zmiana
         Select Case Selitem
            Case 1 : Cls : Upperline : Lcd "Show_params" : Lowerline : Lcd Show_params
            Case 2 : Cls : Upperline : Lcd "Lcd_mode" : Lowerline : Lcd Lcd_mode
            Case 3 : Cls : Upperline : Lcd "Buzzer_on" : Lowerline : Lcd Buzzer_on
            Case 4 : Cls : Upperline : Lcd "Vref" : Lowerline : Lcd Fusing(vref , "#.##") ; " V "
            Case 5 : Cls : Upperline : Lcd "Tr0" : Lowerline : Lcd Tr0 ; Chr(0) ; "C"
            Case 6 : Cls : Upperline : Lcd "Tr1" : Lowerline : Lcd Tr1 ; Chr(0) ; "C"
            Case 7 : Cls : Upperline : Lcd "Tr2" : Lowerline : Lcd Tr2 ; Chr(0) ; "C"
            Case 8 : Cls : Upperline : Lcd "Us_hi_on" : Lowerline : Lcd Fusing(us_hi_on , "#.#") ; " V "
            Case 9 : Cls : Upperline : Lcd "Us_hi_off" : Lowerline : Lcd Fusing(us_hi_off , "#.#") ; " V "
            Case 10 : Cls : Upperline : Lcd "Ovldwait" : Lowerline : Lcd Ovldwait ; " usek. "
         End Select
         Locate 1 , 11 : Lcd "[menu]"
      End If

   'Obsuga klawiatury
      Poschanged = 0
      If Sw1_opt = 0 Then                                   ' opuszczenie menu
         Cls
         Upperline : Lcd "**** Exiting ***"
         Lowerline : Lcd "***** Menu *****"
         Wait 1
         Cls
         Exit Do
      End If
      If Sw2__up = 0 And Selitem < 10 Then                  ' kolejna (wysza) pozycja menu
         Incr Selitem
         Waitms 250
         Poschanged = 1
      Elseif Sw3_dwn = 0 And Selitem > 1 Then               ' poprzednia (nisza) pozycja menu
         Decr Selitem
         Waitms 250
         Poschanged = 1
      End If
      If Sw4_set = 0 Then                                   ' obsuga zmiany wybranego parametru w submenu
         Cursor On , Blink
         Select Case Selitem
            Case 1 : Gosub Show_pars_menu
            Case 2 : Gosub Lcd_mode_menu
            Case 3 : Gosub Buzzer_on_menu
            Case 4 : Gosub Vref_menu
            Case 5 : Gosub Tr0_menu
            Case 6 : Gosub Tr1_menu
            Case 7 : Gosub Tr2_menu
            Case 8 : Gosub Us_hi_on_menu
            Case 9 : Gosub Us_hi_off_menu
            Case 10 : Gosub Ovldwait_menu
         End Select
         Cursor Off , Noblink
         Waitms 250
      End If
   Loop
Return

' Podmenu wywietlania parametrw konfiguracyjnych (zapisanych w EEPROM) przed rozpoczciem waciwej pracy zasilacza
Show_pars_menu:
   Cls
   Do
      Upperline : Lcd "Show_params"
      Lowerline : Lcd Show_params
      Locate 1 , 11 : Lcd "[chng]"
      Waitms 150
      If Sw1_opt = 0 Then                                   ' wyjcie z submenu
         Poschanged = 1                                     ' wymuszenie odwieenia opisu pozycji menu
         Exit Do
      Elseif Sw2__up = 0 Then                               ' zwikszenie wartoci
         Show_params = 1
      Elseif Sw3_dwn = 0 Then                               ' zmniejszenie wartoci
         Show_params = 0
      Elseif Sw4_set = 0 Then                               ' zapisz zmiany
         Writeeeprom Show_params , 1
         Locate 2 , 10 : Lcd "[saved]"
         Wait 1
         Locate 2 , 10 : Lcd "       "
      End If
   Loop
Return

' Tryby wywietlania na LCD: BASIC MODE -> 0 / SERVICE MODE -> 1
Lcd_mode_menu:
   Cls
   Do
      Upperline : Lcd "Lcd_mode"
      Lowerline : Lcd Lcd_mode
      Locate 1 , 11 : Lcd "[chng]"
      Waitms 150
      If Sw1_opt = 0 Then                                   ' wyjcie z submenu
         Poschanged = 1                                     ' wymuszenie odwieenia opisu pozycji menu
         Exit Do
      Elseif Sw2__up = 0 Then                               ' zwikszenie wartoci
         Lcd_mode = 1
      Elseif Sw3_dwn = 0 Then                               ' zmniejszenie wartoci
         Lcd_mode = 0
      Elseif Sw4_set = 0 Then                               ' zapisz zmiany
         Writeeeprom Lcd_mode , 2
         Locate 2 , 10 : Lcd "[saved]"
         Wait 1
         Locate 2 , 10 : Lcd "       "
      End If
   Loop
Return

' Uywanie buzzer'a
Buzzer_on_menu:
   Cls
   Do
      Upperline : Lcd "Buzzer_on"
      Lowerline : Lcd Buzzer_on
      Locate 1 , 11 : Lcd "[chng]"
      Waitms 150
      If Sw1_opt = 0 Then                                   ' wyjcie z submenu
         Poschanged = 1                                     ' wymuszenie odwieenia opisu pozycji menu
         Exit Do
      Elseif Sw2__up = 0 Then                               ' zwikszenie wartoci
         Buzzer_on = 1
      Elseif Sw3_dwn = 0 Then                               ' zmniejszenie wartoci
         Buzzer_on = 0
      Elseif Sw4_set = 0 Then                               ' zapisz zmiany
         Writeeeprom Buzzer_on , 4
         Locate 2 , 10 : Lcd "[saved]"
         Wait 1
         Locate 2 , 10 : Lcd "       "
      End If
   Loop
Return

' Vref - napicie referencyjne, pobierane ze stabilizatora LM7805 (ok. 5V w zakresie: 4.7..5.3V)
Vref_menu:
   Cls
   Do
      Upperline : Lcd "Vref"
      Lowerline : Lcd Fusing(vref , "#.##") ; " V "
      Locate 1 , 11 : Lcd "[chng]"
      Waitms 150
      If Sw1_opt = 0 Then                                   ' wyjcie z submenu
         Poschanged = 1                                     ' wymuszenie odwieenia opisu pozycji menu
         Exit Do
      Elseif Sw2__up = 0 And Vref <= 5.29 Then              ' zwikszenie wartoci
         Vref = Vref + 0.01
      Elseif Sw3_dwn = 0 And Vref => 4.71 Then              ' zmniejszenie wartoci
         Vref = Vref - 0.01
      Elseif Sw4_set = 0 Then                               ' zapisz zmiany
         Writeeeprom Vref , 8
         Locate 2 , 10 : Lcd "[saved]"
         Wait 1
         Locate 2 , 10 : Lcd "       "
      End If
   Loop
   Gosub Pars_recalc                                        ' przeliczenie parametrw zalenych od Vref
Return

' Prg zakoczenia chodzenia wentylatorem {STOP COOLER}
Tr0_menu:
   Cls
   Do
      Upperline : Lcd "Tr0"
      Lowerline : Lcd Tr0 ; Chr(0) ; "C "
      Locate 1 , 11 : Lcd "[chng]"
      Waitms 150
      If Sw1_opt = 0 Then                                   ' wyjcie z submenu
         Poschanged = 1                                     ' wymuszenie odwieenia opisu pozycji menu
         Exit Do
      Elseif Sw2__up = 0 And Tr0 < 60 Then                  ' zwikszenie wartoci
         Incr Tr0
      Elseif Sw3_dwn = 0 And Tr0 > 40 Then                  ' zmniejszenie wartoci
         Decr Tr0
      Elseif Sw4_set = 0 Then                               ' zapisz zmiany
         Writeeeprom Tr0 , 12
         Locate 2 , 10 : Lcd "[saved]"
         Wait 1
         Locate 2 , 10 : Lcd "       "
      End If
   Loop
Return

' Prg rozpoczcia chodzenia wentylatorem {START COOLER}
Tr1_menu:
   Cls
   Do
      Upperline : Lcd "Tr1"
      Lowerline : Lcd Tr1 ; Chr(0) ; "C "
      Locate 1 , 11 : Lcd "[chng]"
      Waitms 150
      If Sw1_opt = 0 Then                                   ' wyjcie z submenu
         Poschanged = 1                                     ' wymuszenie odwieenia opisu pozycji menu
         Exit Do
      Elseif Sw2__up = 0 And Tr1 < 70 Then                  ' zwikszenie wartoci
         Incr Tr1
      Elseif Sw3_dwn = 0 And Tr1 > Tr0 Then                 ' zmniejszenie wartoci
         Decr Tr1
      Elseif Sw4_set = 0 Then                               ' zapisz zmiany
         Writeeeprom Tr1 , 16
         Locate 2 , 10 : Lcd "[saved]"
         Wait 1
         Locate 2 , 10 : Lcd "       "
      End If
   Loop
Return

' Prg zastosowania procedury przegrzania {OVERHEATING}
Tr2_menu:
   Cls
   Do
      Upperline : Lcd "Tr2"
      Lowerline : Lcd Tr2 ; Chr(0) ; "C "
      Locate 1 , 11 : Lcd "[chng]"
      Waitms 150
      If Sw1_opt = 0 Then                                   ' wyjcie z submenu
         Poschanged = 1                                     ' wymuszenie odwieenia opisu pozycji menu
         Exit Do
      Elseif Sw2__up = 0 And Tr2 < 80 Then                  ' zwikszenie wartoci
         Incr Tr2
      Elseif Sw3_dwn = 0 And Tr2 > Tr1 Then                 ' zmniejszenie wartoci
         Decr Tr2
      Elseif Sw4_set = 0 Then                               ' zapisz zmiany
         Writeeeprom Tr2 , 20
         Locate 2 , 10 : Lcd "[saved]"
         Wait 1
         Locate 2 , 10 : Lcd "       "
      End If
   Loop
Return

' Prg napiciowy dla zaczenia grnego zakresu zasilania i sterowania
Us_hi_on_menu:
   Cls
   Do
      Upperline : Lcd "Us_hi_on"
      Lowerline : Lcd Fusing(us_hi_on , "#.#") ; " V "
      Locate 1 , 11 : Lcd "[chng]"
      Waitms 150
      If Sw1_opt = 0 Then                                   ' wyjcie z submenu
         Poschanged = 1                                     ' wymuszenie odwieenia opisu pozycji menu
         Exit Do
      Elseif Sw2__up = 0 And Us_hi_on < 20 Then             ' zwikszenie wartoci
         Us_hi_on = Us_hi_on + 0.1
      Elseif Sw3_dwn = 0 And Us_hi_on > 10 Then             ' zmniejszenie wartoci
         Us_hi_on = Us_hi_on - 0.1
      Elseif Sw4_set = 0 Then                               ' zapisz zmiany
         Writeeeprom Us_hi_on , 24
         Locate 2 , 10 : Lcd "[saved]"
         Wait 1
         Locate 2 , 10 : Lcd "       "
      End If
   Loop
Return

' Prg napiciowy dla zaczenia dolnego zakresu zasilania i sterowania
Us_hi_off_menu:
   Cls
   Do
      Upperline : Lcd "Us_hi_off"
      Lowerline : Lcd Fusing(us_hi_off , "#.#") ; " V "
      Locate 1 , 11 : Lcd "[chng]"
      Waitms 150
      If Sw1_opt = 0 Then                                   ' wyjcie z submenu
         Poschanged = 1                                     ' wymuszenie odwieenia opisu pozycji menu
         Exit Do
      Elseif Sw2__up = 0 And Us_hi_off < Us_hi_on Then      ' zwikszenie wartoci
         Us_hi_off = Us_hi_off + 0.1
      Elseif Sw3_dwn = 0 And Us_hi_off > 9 Then             ' zmniejszenie wartoci
         Us_hi_off = Us_hi_off - 0.1
      Elseif Sw4_set = 0 Then                               ' zapisz zmiany
         Writeeeprom Us_hi_off , 28
         Locate 2 , 10 : Lcd "[saved]"
         Wait 1
         Locate 2 , 10 : Lcd "       "
      End If
   Loop
Return

' Opnienie dodane w obsudze przerwania od przecienia
Ovldwait_menu:
   Cls
   Do
      Upperline : Lcd "Ovldwait"
      Lowerline : Lcd Ovldwait ; " usek. "
      Locate 1 , 11 : Lcd "[chng]"
      Waitms 150
      If Sw1_opt = 0 Then                                   ' wyjcie z submenu
         Poschanged = 1                                     ' wymuszenie odwieenia opisu pozycji menu
         Exit Do
      Elseif Sw2__up = 0 And Ovldwait <= 9999 Then          ' zwikszenie wartoci
         Ovldwait = Ovldwait + 1
      Elseif Sw3_dwn = 0 And Ovldwait >= 2 Then             ' zmniejszenie wartoci
         Ovldwait = Ovldwait - 1
      Elseif Sw4_set = 0 Then                               ' zapisz zmiany
         Writeeeprom Ovldwait , 32
         Locate 2 , 10 : Lcd "[saved]"
         Wait 1
         Locate 2 , 10 : Lcd "       "
      End If
   Loop
Return